EDIT - bug #6389

Returning a Map in cdmlib leads to data loss
01/26/2017 07:44 PM - Patrick Plitzner
Target version: Release 5.0

Severity: critical Found in Version:

Description

| added the following method to IService/ServiceBase. | then invoked it on the taxeditor side in different places. The returned map on
the taxeditor side never has the expected size of i but only contains the first half of the entries. On the cdmlib side it is completely
filled.

public Map returnMap() {

Map map = new HashMap<>();
for(int i=0;i<10;1i++) {
map.put (i, 1i);

}

return map;

In a quick search in the service methods | only found save methods also returning maps but | am not sure if the return values are
used on the taxeditor side.

Associated revisions

Revision 1b7f25fe - 01/26/2017 07:53 PM - pplitzner

ref #6389 avoid service call for icon determination (performance)

e additionally the service call returned undeterministic results

Revision 98baf5f8 - 02/27/2018 02:30 PM - Patrick Plitzner
fix #6389 Fixed cache loader method

e the wrong collection size was used for iteration leaving out the second half of map entries

Revision 1c9d09b9 - 03/22/2018 03:47 PM - Andreas Kohlbecker
ref #7325 applying taxeditor changeset (98baf5f ref #6389) onto cdmlib-cache

History

#1 - 01/30/2017 02:37 PM - Andreas Miiller

Check if this method is used elsewhere. If not make it deprecated with reason that it currently gives not the expected results but may be fixed in future
and link to the ticket and set to Reviewed with priority 11.

#2 - 01/30/2017 02:38 PM - Andreas Miiller
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 4.6

#3 - 03/10/2017 08:47 PM - Andreas Miiller
- Target version changed from Release 4.6 to Release 4.7

#4 - 05/11/2017 11:43 AM - Andreas Miiller

- Target version changed from Release 4.7 to Release 4.8

#5 - 07/07/2017 10:02 AM - Patrick Plitzner

- Target version changed from Release 4.8 to Release 4.9

#6 - 07/21/2017 10:30 AM - Andreas Miiller

- Target version changed from Release 4.9 to Release 4.10

#7 - 09/24/2017 04:41 PM - Andreas Miiller

- Target version changed from Release 4.10 to Release 4.11

#8 - 11/08/2017 11:21 AM - Andreas Miiller

- Target version changed from Release 4.11 to Release 4.12

#9 - 12/05/2017 02:16 PM - Andreas Miiller

- Target version changed from Release 4.12 to Release 4.13

#10 - 01/31/2018 12:30 PM - Andreas Miiller

- Target version changed from Release 4.13 to Release 4.14

#11 - 02/15/2018 03:25 PM - Andreas Miiller

- Target version changed from Release 4.14 to Release 5.0

#12 - 02/21/2018 11:55 AM - Andreas Muller

- Description updated

#13 - 02/21/2018 11:56 AM - Andreas Muller

- Description updated

#14 - 02/26/2018 03:35 PM - Patrick Plitzner
- Subject changed from listTypeDesignations() returns undeterministic results in specimen editor to Returning a Map in cdmlib leads to data loss

- Severity changed from normal to critical

#15 - 02/26/2018 03:45 PM - Patrick Plitzner

- Description updated

#16 - 02/27/2018 10:10 AM - Patrick Plitzner

- Description updated

#17 - 02/27/2018 10:46 AM - Andreas Kohlbecker

- Status changed from New to Feedback

To me it looks like this problem is related to Spring HTTPInvoker and the serilazization/de-serialization of maps.

For serialization and de-serialization of Maps the equals() and hashCode() methods are crucial and that the types of value and key are implementing
Serializable. In your test code you are using int as key and value. But maps hold Objects, so internally java will need to convert these into Objects by

un-/boxing.
First of all | would rewrite the test method, so that the map is type save and so that un-/boxing is not needed:

public Map<Integer, Integer> returnMap() {
Map<Integer, Integer> map = new HashMap<>();
for(int i=0;1<10;i++) {
map.put (Integer.valueOf (i), Integer.valueOf (i));
}

return map;
see also e.g.:

https://stackoverflow.com/questions/2747819/serializing-and-deserializing-a-map-with-key-as-string#2747911

#18 - 02/27/2018 11:09 AM - Patrick Plitzner

There is no change with using Integer.valueOf(i)

#19 - 02/27/2018 12:17 PM - Andreas Kohlbecker

Patrick Plitzner wrote:

There is no change with using Integer.valueOf(i)

Ok, this is good news!
Maybe it helps to take a look at the serialization and deserialization of Objects in Httplnvoker.

BTW: You could also test if the serialization and deserialization with jdk is working, see ObjectStreams.

#20 - 02/27/2018 01:54 PM - Patrick Plitzner

Tested serialization and deserialization for plain java with the following:
public static void main(String args[]) {

HashMap<Integer, Integer> map = new HashMap<>();
for(int i=0;1<100;i++) {
map.put (Integer.valueOf (i), Integer.valueOf (1)) ;
}
tryf
FileOutputStream fos =
new FileOutputStream("map.file");
ObjectOutputStream oos = new ObjectOutputStream(fos);
oos.writeObject (map) ;
ocos.close();
fos.close();
System.out.println("Serialized HashMap data is saved in map.file");

map = null;

FileInputStream fis = new FileInputStream("map.file");
ObjectInputStream ois = new ObjectInputStream(fis);
map = (HashMap) ois.readObject();

ois.close();
fis.close();
}catch (Exception e) {
e.printStackTrace();
return;
}
System.out.println ("Deserialized HashMap");
map.forEach ((key, value)->System.out.println("key: "+ key + ", wvalue: "+value));

}
This works fine. So it must have something to do with the serialization process of spring.

#21 - 02/27/2018 02:17 PM - Patrick Plitzner

The problem has nothing to do with the deserialization but with CachelLoader.load(Map map, List alreadyVisitedEntities, boolean update) where the
Map is not reconstructed correctly.

#22 - 02/27/2018 02:30 PM - Patrick Plitzner
- Status changed from Feedback to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|98baf5{86b1e6f5d3b3e1cd57b1f2907e2305eb3.

#23 - 02/27/2018 02:46 PM - Patrick Plitzner
- Assignee changed from Patrick Plitzner to Andreas Kohlbecker

- % Done changed from 50 to 0

In the CacheLoader class the map was deconstructed into an array of twice the size containing keys and values alternating. Then the map was
re-built but the iteration was only over half the size of the array. So the resulting map was always half the size and only contained the first half of
entries.

| checked for cdmlib service methods that have a Map as return value and there are also some, but few, methods, other than save methods, that use
Maps and that are also used in the taxeditor. So if there were any bugs related to these methods they could also be solved with this fix.

#24 - 02/27/2018 03:04 PM - Patrick Plitzner
- Description updated

#25 - 03/22/2018 03:53 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed
- Assignee changed from Andreas Kohlbecker to Patrick Plitzner

- % Done changed from 0 to 100

looks ok and | applied your changeset 98baf5f onto cdmlib-cache
